/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.80.0
        Device            :  PIC16F18857
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.10 and above
        MPLAB 	          :  MPLAB X 5.30	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set S1 aliases
#define S1_TRIS                 TRISAbits.TRISA0
#define S1_LAT                  LATAbits.LATA0
#define S1_PORT                 PORTAbits.RA0
#define S1_WPU                  WPUAbits.WPUA0
#define S1_OD                   ODCONAbits.ODCA0
#define S1_ANS                  ANSELAbits.ANSA0
#define S1_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define S1_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define S1_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define S1_GetValue()           PORTAbits.RA0
#define S1_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define S1_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define S1_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define S1_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define S1_SetPushPull()        do { ODCONAbits.ODCA0 = 0; } while(0)
#define S1_SetOpenDrain()       do { ODCONAbits.ODCA0 = 1; } while(0)
#define S1_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define S1_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set S2 aliases
#define S2_TRIS                 TRISAbits.TRISA1
#define S2_LAT                  LATAbits.LATA1
#define S2_PORT                 PORTAbits.RA1
#define S2_WPU                  WPUAbits.WPUA1
#define S2_OD                   ODCONAbits.ODCA1
#define S2_ANS                  ANSELAbits.ANSA1
#define S2_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define S2_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define S2_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define S2_GetValue()           PORTAbits.RA1
#define S2_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define S2_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define S2_SetPullup()          do { WPUAbits.WPUA1 = 1; } while(0)
#define S2_ResetPullup()        do { WPUAbits.WPUA1 = 0; } while(0)
#define S2_SetPushPull()        do { ODCONAbits.ODCA1 = 0; } while(0)
#define S2_SetOpenDrain()       do { ODCONAbits.ODCA1 = 1; } while(0)
#define S2_SetAnalogMode()      do { ANSELAbits.ANSA1 = 1; } while(0)
#define S2_SetDigitalMode()     do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set S3 aliases
#define S3_TRIS                 TRISAbits.TRISA2
#define S3_LAT                  LATAbits.LATA2
#define S3_PORT                 PORTAbits.RA2
#define S3_WPU                  WPUAbits.WPUA2
#define S3_OD                   ODCONAbits.ODCA2
#define S3_ANS                  ANSELAbits.ANSA2
#define S3_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define S3_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define S3_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define S3_GetValue()           PORTAbits.RA2
#define S3_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define S3_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define S3_SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define S3_ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define S3_SetPushPull()        do { ODCONAbits.ODCA2 = 0; } while(0)
#define S3_SetOpenDrain()       do { ODCONAbits.ODCA2 = 1; } while(0)
#define S3_SetAnalogMode()      do { ANSELAbits.ANSA2 = 1; } while(0)
#define S3_SetDigitalMode()     do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set Green aliases
#define Green_TRIS                 TRISAbits.TRISA3
#define Green_LAT                  LATAbits.LATA3
#define Green_PORT                 PORTAbits.RA3
#define Green_WPU                  WPUAbits.WPUA3
#define Green_OD                   ODCONAbits.ODCA3
#define Green_ANS                  ANSELAbits.ANSA3
#define Green_SetHigh()            do { LATAbits.LATA3 = 1; } while(0)
#define Green_SetLow()             do { LATAbits.LATA3 = 0; } while(0)
#define Green_Toggle()             do { LATAbits.LATA3 = ~LATAbits.LATA3; } while(0)
#define Green_GetValue()           PORTAbits.RA3
#define Green_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define Green_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define Green_SetPullup()          do { WPUAbits.WPUA3 = 1; } while(0)
#define Green_ResetPullup()        do { WPUAbits.WPUA3 = 0; } while(0)
#define Green_SetPushPull()        do { ODCONAbits.ODCA3 = 0; } while(0)
#define Green_SetOpenDrain()       do { ODCONAbits.ODCA3 = 1; } while(0)
#define Green_SetAnalogMode()      do { ANSELAbits.ANSA3 = 1; } while(0)
#define Green_SetDigitalMode()     do { ANSELAbits.ANSA3 = 0; } while(0)

// get/set Blue aliases
#define Blue_TRIS                 TRISAbits.TRISA4
#define Blue_LAT                  LATAbits.LATA4
#define Blue_PORT                 PORTAbits.RA4
#define Blue_WPU                  WPUAbits.WPUA4
#define Blue_OD                   ODCONAbits.ODCA4
#define Blue_ANS                  ANSELAbits.ANSA4
#define Blue_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define Blue_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define Blue_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define Blue_GetValue()           PORTAbits.RA4
#define Blue_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define Blue_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define Blue_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define Blue_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define Blue_SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define Blue_SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define Blue_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define Blue_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set Red aliases
#define Red_TRIS                 TRISAbits.TRISA5
#define Red_LAT                  LATAbits.LATA5
#define Red_PORT                 PORTAbits.RA5
#define Red_WPU                  WPUAbits.WPUA5
#define Red_OD                   ODCONAbits.ODCA5
#define Red_ANS                  ANSELAbits.ANSA5
#define Red_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define Red_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define Red_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define Red_GetValue()           PORTAbits.RA5
#define Red_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define Red_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define Red_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define Red_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define Red_SetPushPull()        do { ODCONAbits.ODCA5 = 0; } while(0)
#define Red_SetOpenDrain()       do { ODCONAbits.ODCA5 = 1; } while(0)
#define Red_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define Red_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCAF0 pin functionality
 * @Example
    IOCAF0_ISR();
 */
void IOCAF0_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCAF0 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCAF0 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF0_SetInterruptHandler(MyInterruptHandler);

*/
void IOCAF0_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCAF0 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCAF0_SetInterruptHandler() method.
    This handler is called every time the IOCAF0 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF0_SetInterruptHandler(IOCAF0_InterruptHandler);

*/
extern void (*IOCAF0_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCAF0 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCAF0_SetInterruptHandler() method.
    This handler is called every time the IOCAF0 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF0_SetInterruptHandler(IOCAF0_DefaultInterruptHandler);

*/
void IOCAF0_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCAF1 pin functionality
 * @Example
    IOCAF1_ISR();
 */
void IOCAF1_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCAF1 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCAF1 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF1_SetInterruptHandler(MyInterruptHandler);

*/
void IOCAF1_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCAF1 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCAF1_SetInterruptHandler() method.
    This handler is called every time the IOCAF1 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF1_SetInterruptHandler(IOCAF1_InterruptHandler);

*/
extern void (*IOCAF1_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCAF1 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCAF1_SetInterruptHandler() method.
    This handler is called every time the IOCAF1 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF1_SetInterruptHandler(IOCAF1_DefaultInterruptHandler);

*/
void IOCAF1_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCAF2 pin functionality
 * @Example
    IOCAF2_ISR();
 */
void IOCAF2_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCAF2 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCAF2 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF2_SetInterruptHandler(MyInterruptHandler);

*/
void IOCAF2_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCAF2 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCAF2_SetInterruptHandler() method.
    This handler is called every time the IOCAF2 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF2_SetInterruptHandler(IOCAF2_InterruptHandler);

*/
extern void (*IOCAF2_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCAF2 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCAF2_SetInterruptHandler() method.
    This handler is called every time the IOCAF2 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF2_SetInterruptHandler(IOCAF2_DefaultInterruptHandler);

*/
void IOCAF2_DefaultInterruptHandler(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/