# 1 "bme_lib.c"
# 1 "<built-in>" 1
# 1 "<built-in>" 3
# 288 "<built-in>" 3
# 1 "<command line>" 1
# 1 "<built-in>" 2
# 1 "C:\\Program Files (x86)\\Microchip\\xc8\\v2.10\\pic\\include\\language_support.h" 1 3
# 2 "<built-in>" 2
# 1 "bme_lib.c" 2




# 1 "./bme_lib.h" 1



typedef unsigned long long uint32;
typedef signed long long int32;


uint32 hum_raw, temp_raw, pres_raw;
int32 t_fine;


unsigned int T1;
int T2, T3;
unsigned int P1;
int P2, P3, P4, P5, P6, P7, P8, P9;
unsigned int H1, H3;
int H2, H4, H5, H6;

void bme_init(void);
void bme_gettrim(void);
void bme_getdata(void);
int32 calib_temp(int32 adc_T);
uint32 calib_pres(int32 adc_P);
uint32 calib_hum(int32 adc_H);
# 5 "bme_lib.c" 2

# 1 "./i2c_lib.h" 1





void SendI2C(unsigned char Adrs, unsigned char Data);
void CmdI2C(unsigned char Adrs, unsigned char Reg, unsigned char Data);
void GetDataI2C(unsigned char Adrs, unsigned char *Buffer, unsigned char Cnt);
# 6 "bme_lib.c" 2







void bme_init(void){

    CmdI2C(0x76,0xE0, 0xB6);

    CmdI2C(0x76, 0xF2, 0x01);
    CmdI2C(0x76, 0xF4, 0x27);
    CmdI2C(0x76, 0xF5, 0xA0);
}



void bme_getdata(void){
    unsigned char buf[8];

    SendI2C(0x76, 0xF7);
    GetDataI2C(0x76, buf, 8);

    pres_raw = (uint32)(((uint32)buf[0] << 12) + ((uint32)buf[1] << 4) + ((uint32)buf[2] >> 4));
    temp_raw = (uint32)(((uint32)buf[3] << 12) + ((uint32)buf[4] << 4) + ((uint32)buf[5] >> 4));
    hum_raw = (uint32)(((uint32)buf[6] << 8) + (uint32)buf[7]);
}



void bme_gettrim(void){
    unsigned char buf[40];


    SendI2C(0x76, 0x88);
    GetDataI2C(0x76, buf, 24);
    SendI2C(0x76, 0xA1);
    GetDataI2C(0x76, buf+24, 1);
    SendI2C(0x76, 0xE1);
    GetDataI2C(0x76, buf+25, 7);

    T1 = (unsigned int)((buf[1] << 8) | buf[0]);
    T2 = (int)((buf[3] << 8) | buf[2]);
    T3 = (int)((buf[5] << 8) | buf[4]);
    P1 = (unsigned int)((buf[7] << 8) | buf[6]);
    P2 = (int)((buf[9] << 8) | buf[8]);
    P3 = (int)((buf[11] << 8) | buf[10]);
    P4 = (int)((buf[13] << 8) | buf[12]);
    P5 = (int)((buf[15] << 8) | buf[14]);
    P6 = (int)((buf[17] << 8) | buf[16]);
    P7 = (int)((buf[19] << 8) | buf[18]);
    P8 = (int)((buf[21] << 8) | buf[20]);
    P9 = (int)((buf[23] << 8) | buf[22]);
    H1 = (unsigned int)buf[24];
    H2 = (int)((buf[26] << 8) | buf[25]);
    H3 = (unsigned int)buf[27];
    H4 = (int)((buf[28] << 4) | (0x0F & buf[29]));
    H5 = (int)((buf[30] << 4) | ((buf[29] >> 4) & 0x0F));
    H6 = (int)buf[31];
}



int32 calib_temp(int32 adc_T){
    int32 var1, var2, T;

    var1 = ((((adc_T >> 3) - ((int32)T1 << 1))) *((int32)T2)) >> 11;
    var2 = (((((adc_T >> 4) - ((int32)T1)) *((adc_T >> 4)-((int32)T1))) >> 12) *((int32)T3)) >> 14;
    t_fine = var1 + var2;
    T = (t_fine * 5 + 128) >> 8;
    return T;
}



uint32 calib_pres(int32 adc_P){
    int32 var1, var2;
    uint32 P;

    var1 = (t_fine >> 1) - (int32)64000;
    var2 = (((var1 >> 2) * (var1 >> 2)) >>11) * (int32)P6;
    var2 = var2 + ((var1 * (int32)P5) << 1);
    var2 = (var2 >> 2) + ((int32)P4 << 16);
    var1 = ((((int32)P3 * (((var1 >> 2)*(var1 >> 2)) >> 13)) >> 3) + (((int32)P2 * var1)>>1)) >> 18;
    var1 = (((int32)32768 + var1) * (int32)P1) >> 15;
    if(var1 == 0)
        return 0;
    P = ((uint32)(((int32)1048576 - adc_P) - (var2 >> 12))) * 3125;
    if(P < 0x80000000)
        P = (P << 1) / (uint32)var1;
    else
        P = (P / (uint32)var1) * 2;
    var1 = (P9 * ((int32)(((P >> 3) * (P >> 3)) >> 13))) >> 12;
    var2 = (((int32)(P >> 2)) * (int32)P8) >> 13;
    P = (uint32)((int32)P + ((var1 + var2 + (int32)P7) >> 4));
    return P;
}



uint32 calib_hum(int32 adc_H){
    int32 v_x1;

    v_x1 = (t_fine - ((int32)76800));
    v_x1 = (((((adc_H << 14) - (((int32)H4) << 20) - (((int32)H5) * v_x1))+
            ((int32)16384)) >> 15) * (((((((v_x1 * ((int32)H6)) >> 10) *
            (((v_x1 * ((int32)H3)) >>11) + ((int32)32768))) >> 10) +
            ((int32)2097152)) * ((int32)H2) + 8192) >> 14));
    v_x1 = (v_x1 - (((((v_x1 >> 15) * (v_x1 >> 15)) >> 7) * ((int32)H1)) >> 4));
    if(v_x1 < 0)
        v_x1 = 0;
    if(v_x1 > 419430400)
        v_x1 = 419430400;
    return (uint32)(v_x1 >> 12);
}
