/**
  DSM3 Generated Driver File

  @Company
    Microchip Technology Inc.

  @File Name
    dsm3.c

  @Summary
    This is the generated driver implementation file for the DSM3 driver using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This source file provides APIs for DSM3.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65
        Device            :  PIC16F1778
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45 
        MPLAB 	          :  MPLAB X 4.10
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

/**
  Section: Included Files
*/

#include <xc.h>
#include "dsm3.h"

/**
  Section: DSM3 APIs
*/

void DSM3_Initialize(void)
{
    // set the DSM3 to the options selected in the User Interface
    
    // Modulator Output Pin Polarity is not inverted
    MD3CON0bits.MD3OPOL = 0;

    // Modulation Low Carrier Synchronization is disabled
    MD3CON1bits.MD3CLSYNC = 0;

    // Modulation Low Carrier Polarity is not inverted
    MD3CON1bits.MD3CLPOL = 0;

    // Modulation High Carrier Synchronization is disabled
    MD3CON1bits.MD3CHSYNC = 0;

    // Modulation High Carrier Polarity is not inverted
    MD3CON1bits.MD3CHPOL = 0;

    // MD3MS MDBIT; 
    MD3SRC = 0x01;
    
    // MD3CH PWM3; 
    MD3CARH = 0x07;
    
    // MD3CL PWM9; 
    MD3CARL = 0x09;
    
    // Enable the Modulator
    MD3CON0bits.MD3EN = 1;
}

void DSM3_ManualModulationSet (void)
{
    // Set MDBIT to High, Modulator uses high carrier source
    MD3CON0bits.MD3BIT = 1;
}

void DSM3_ManualModulationClear (void)
{
    // Set MDBIT to Low, Modulator uses low carrier source
    MD3CON0bits.MD3BIT = 0;
}

void DSM3_ManualModulationToggle (void)
{
    // Toggle the MDBIT
    MD3CON0bits.MD3BIT ^= 1;
}

void DSM3_ModulationStart (void)
{
    // Enables module and begins modulation
    MD3CON0bits.MD3EN = 1;
}

void DSM3_ModulationStop (void)
{
    // Disables module and stops modulation
    MD3CON0bits.MD3EN = 0;
}
/**
 End of File
*/