/**
  DAC2 Generated Driver File

  @Company
    Microchip Technology Inc.

  @File Name
    dac2.c

  @Summary
    This is the generated driver implementation file for the DAC2 driver using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This source file provides APIs for DAC2.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.80.0
        Device            :  PIC16F1778
        Driver Version    :  2.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.10 and above
        MPLAB 	          :  MPLAB X 5.30
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

/**
  Section: Included Files
*/

#include <xc.h>
#include "dac2.h"

/**
  Section: Macros
*/

/**
 *  Loads data from DAC buffer onto the DAC output
 */
#define DAC2_DoubleBufferLatch() \
    (DACLDbits.DAC2LD = 1)

/**
  Section: DAC2 APIs
*/

void DAC2_Initialize(void)
{
    // DAC2FM right justified; DACEN enabled; DACNSS VSS; DACPSS VDD; DACOE1 disabled; DACOE2 disabled; 
    DAC2CON0 = 0x80;
    // 
    DAC2REFH = 0x00;
    // 
    DAC2REFL = 0xCD;
    //Loading DAC2 double buffer data to latch.
    DAC2_DoubleBufferLatch();
}


void DAC2_Load16bitInputData(uint16_t input16BitData)
{
    //DAC input reference range should be 16bit.
    //Input data left justified.
    DAC2CON0bits.DAC2FM = 1;
    
    //Loading 16bit data to DAC2
    DAC2REFL  = (uint8_t) input16BitData;  
    DAC2REFH  = (uint8_t)(input16BitData >> 8);
    //Loading DAC2 double buffer data to latch.
    DAC2_DoubleBufferLatch();
}

void DAC2_Load10bitInputData(uint16_t input10BitData)
{
    //DAC input reference range should be 10bit.
    //Input data right justified.
    DAC2CON0bits.DAC2FM = 0;
    
    //Loading 10bit data to DAC2
    DAC2REFL  = (uint8_t) input10BitData;  
    DAC2REFH  = (uint8_t)(input10BitData >> 8);
    //Loading DAC2 double buffer data to latch.
    DAC2_DoubleBufferLatch();
}

void DAC2_Load8bitInputData(uint8_t input8BitData)
{
    //DAC input reference range should be 8 bit.
    //Input data right justified.
    DAC2CON0bits.DAC2FM = 0;
    
    //Loading 10bit data to DAC2
    DAC2REFL  = input8BitData;  
    //Loading DAC2 double buffer data to latch.
    DAC2_DoubleBufferLatch();
}

uint16_t DAC2_Read10BitInputData(void) {
    // Right justified, to match ?load? function
    DAC2CON0bits.DAC2FM = 0;

    // Read data
    uint16_t data = ((uint16_t) DAC2REFH) << 8;
    data |= ((uint16_t) DAC2REFL);

    return data;
}
/**
 End of File
*/ 



