/**
  MATHACC Generated Driver  File

  @Company
    Microchip Technology Inc.

  @File Name
    mathacc.c

  @Summary
    This is the generated driver implementation for the MATHACC driver using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This source file provides APIs for MATHACC.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65
        Device            :  PIC16F1619
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.10
*/

/**
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

/**
  Section: Included Files
*/

#include <xc.h>
#include "mathacc.h"

/**
  Section: MATHACC APIs
*/

void MATHACC_Initialize(void)
{
    // set the PID module to the options selected in the User Interface
    // PID1MODE unsigned i/p, without acc; PID1EN enabled; 
    PID1CON = 0x80;


}

  
MATHACCResult MATHACC_AdditionAndMultiplicationResultGet(uint16_t a, uint16_t b, uint16_t c)
{
    MATHACCResult result;	
    PID1K1H  = (uint8_t) ((c & 0xFF00) >> 8);
    PID1K1L  = (uint8_t)  (c & 0x00FF);
    PID1SETH = (uint8_t) ((b & 0xFF00) >> 8);
    PID1SETL = (uint8_t)  (b & 0x00FF);
    PID1INH  = (uint8_t) ((a & 0xFF00) >> 8);
    PID1INL  = (uint8_t)  (a & 0x00FF);   // starts module operation
	
    while (PID1CONbits.PID1BUSY == 1);  // wait for the module to complete 
	
    result.byteLL = PID1OUTLL;
    result.byteLH = PID1OUTLH;
    result.byteHL = PID1OUTHL;
    result.byteHH = PID1OUTHH;
    result.byteU  = PID1OUTU;
	
    return result;
}

MATHACCResult MATHACC_AdditionResultGet(uint16_t a, uint16_t b)
{
    MATHACCResult result;
	
	PID1K1H  = 0;
    PID1K1L  = 1;   
    PID1SETH = (uint8_t) ((b & 0xFF00) >> 8);
    PID1SETL = (uint8_t) (b & 0x00FF);
    PID1INH  = (uint8_t) ((a & 0xFF00) >> 8);
    PID1INL  = (uint8_t) (a & 0x00FF);   // starts module operation
	
    while (PID1CONbits.PID1BUSY == 1);  // wait for the module to complete
	
    result.byteLL = PID1OUTLL;
    result.byteLH = PID1OUTLH;
    result.byteHL = PID1OUTHL;
    result.byteHH = PID1OUTHH;
    result.byteU  = PID1OUTU;
	
    return result;
}

MATHACCResult MATHACC_MultiplicationResultGet(uint16_t b, uint16_t c)
{
    MATHACCResult result;
	
    PID1K1H  = (uint8_t) ((c & 0xFF00) >> 8);
    PID1K1L  = (uint8_t)  (c & 0x00FF);
    PID1SETH = (uint8_t) ((b & 0xFF00) >> 8);
    PID1SETL = (uint8_t)  (b & 0x00FF);
    PID1INH  = 0;
    PID1INL  = 0;    // starts module operation
	
    while (PID1CONbits.PID1BUSY == 1);  // wait for the module to complete
	
    result.byteLL = PID1OUTLL;
    result.byteLH = PID1OUTLH;
    result.byteHL = PID1OUTHL;
    result.byteHH = PID1OUTHH;
    result.byteU  = PID1OUTU;

    return result;
}
                        

MATHACCResult MATHACC_ResultGet(void)
{
    MATHACCResult data;

    data.byteLL = PID1OUTLL;
    data.byteLH = PID1OUTLH;
    data.byteHL = PID1OUTHL;
    data.byteHH = PID1OUTHH;
    data.byteU  = PID1OUTU;

    return data;
}

void MATHACC_ClearResult(void)
{
    PID1OUTLL = 0;
    PID1OUTLH = 0;
    PID1OUTHL = 0;
    PID1OUTHH = 0;
    PID1OUTU  = 0;
}

bool MATHACC_HasOverflowOccured(void)
{
    bool retVal = false;
    
    if (1 == PIR5bits.PID1EIF)
    {
        retVal = true;
        PIR5bits.PID1EIF = 0;
    }
    
    return retVal;
}
// end of file
     
        

        
